//--------------------------------------------------------------------
//   .mq4 
//--------------------------------------------------------------------
#property copyright "Copyright  Equilibrium 2012"
#property link      "Equilibrium007@mail.ru"
//--------------------------------------------------------------------
                                        //    15
extern int StopLoss   =20;              // SL   
extern int TakeProfit =150;             //    
extern double Lots       =1;            //   . 
extern double Prots      =0.07;         //   

extern int Kperiod       =5;            //     %
extern int Dperiod       =3;            //      %D
extern int Slowing       =3;            //  
extern int Price_field   =0;            //     

double Lot,                             // .   .
       Lts,                             // .   .
       SL,                              // SL   
       TP,                              // TP  
       Min_Lot,                         //   
       Step,                            //    
       Free,                            //   
       One_Lot,                         //   
       Price;                           //   
bool   Work=true,                       //   .
       Ans=false;                       //    
       
string Symb;                            //  . 
      
    

int    M_1,                             //  MAIN  1 
       M_2,                             //  MAIN  2 
       S_1,                             //  SIGNAL  1 
       S_2,                             //  SIGNAL  2 
       Total;                           //       
static int Ticket;             
//--------------------------------------------------------------------
int start()
  {                  // .
   
  
    Total=OrdersTotal();                        //  
    Symb=Symbol();
   if(Bars < Kperiod)                           //  
     {
      Alert("   .   .");
      return;                                   //   start()
     }
   if(Work==false)                              //  
     {
      Alert(" .   .");
      return;                                   //   start()
     }  
//------------------------------------------------------------------
                      //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   

   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  

   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   if (Lts*One_Lot > Free)                      //   .
     {
      Alert("     ", Lts," ");
      return;                                   //   start()
     }
//---------------------------------------------------------------------  
                 //    ..
   
   M_1=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_MAIN,  1);
   M_2=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_MAIN,  2);
   S_1=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_SIGNAL,1);
   S_2=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_SIGNAL,2);

                        //  
   
   if (M_2 < S_2 && M_1==S_1)                    //  . Buy  . Sell 
     {
      if (Total>0)
        {
        Close_Order_S(Ticket,Ans,Lts); 
        }
      
        Ticket = Open_Order_B(StopLoss,Lts); 
                                                                         
     } 
   if (M_2 > S_2 && M_1==S_1)                    //  . Sell  . Buy        
     {  
      if (Total>0)
        {
        Close_Order_B(Ticket,Ans,Lts);   
        }                           
      
        Ticket = Open_Order_S(StopLoss,Lts); 
                                                                   
     }
   if (M_2 > S_2 && M_1 > S_1 && Total>0)          //   
     {
      Alert("  .");        //   
     }else  
     {
      Alert("   .");                //   
     }   
   if (M_2 < S_2 && M_1 < S_1 && Total>0)          //   
     {
      Alert("  .");        //   
     }else 
     {
      Alert("   .");                //   
     }               
   return;                                         //   start()
  }
//--------------------------------------------------------------------
                          // -  
int Fun_Error(int Error)                        
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//--------------------------------------------------------------------
//  -
                         //  

int  Open_Order_B (int StopLoss,double Lts) 
       {                                          
         while (true)
         {
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket);
            return;                             //   while
           }
         if (Fun_Error(GetLastError())==1)      //  
            {
            continue;                           //  
            }                           
          }
         return (Ticket);                       //   while
       } 
      
      
int Open_Order_S (int StopLoss,double Lts)
       {                                       
         while (true)
         {
         RefreshRates();                        //  
         SL=Ask + New_Stop(StopLoss)*Point;     //  SL .
         TP=Ask - New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Sell.  ..");
         Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP);// Sel
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            return;                             //   while
           }
         if (Fun_Error(GetLastError())==1)      //  
            {
            continue;                           //  
            }     
          }                      
         return (Ticket);                       //   while
       }
                                      
                          //  
   
void Close_Order_B (int Ticket,bool Ans, double Lts)
          { 
           while (true)
           {                                     
           Alert("  Buy ",Ticket,".  ..");
           RefreshRates();                        //  
           Ans=OrderClose(Ticket,Lts,Bid,2);      //  Buy
           if (Ans==true)                         //  :)
             {
              Alert ("  Buy ",Ticket); //    
             }
           if (Fun_Error(GetLastError())==1)      //  
              {
              continue;                           //  
              }                           
           }
           return;
          } 
          
void Close_Order_S (int Ticket,bool Ans, double Lts)
          {                                       
           while (true)
           {
           Alert("  Sell ",Ticket,".  ..");
           RefreshRates();                        //  
           Ans=OrderClose(Ticket,Lts,Ask,2);      //  Sell
           if (Ans==true)                         //  :)
             {
              Alert ("  Sell ",Ticket);//    
             }
           
           if (Fun_Error(GetLastError())==1)      //  
              {
              continue;                           //  
              }                          
           }
           return;   
          }
//--------------------------------------------------------------------------
                           //  -.
int New_Stop(int Parametr)                      
  {
   Symb=Symbol();
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
   if (Parametr<Min_Dist)                       //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }